<?php
class xmltokml_KML_markup {
  function xmltokml_KML_open() {
    $kml_out  = '<?xml version="1.0" encoding="UTF-8"?>' . "\r\n";
    $kml_out .= '<kml xmlns="http://earth.google.com/kml/2.2">' . "\r\n";
    $kml_out .= '  <Document>' . "\r\n";
    return $kml_out;
  } // function xmltokml_KML_open

  function xmltokml_KML_net($url, $name, $description, $vis, $open, $refreshVis, $flyToView) {
    $kml_out = "<Folder>";
    $kml_out .= "		<name>".$name."</name>";
    $kml_out .= "		<visibility>".$vis."</visibility>";
    $kml_out .= "		<open>".$open."</open>";
    $kml_out .= "		<description>";
    $kml_out .= "			".$description;
    $kml_out .= "		</description>";
    $kml_out .= "		<NetworkLink>";
    $kml_out .= "			<name>".$name."</name>";
    $kml_out .= "			<visibility>".$vis."</visibility>";
    $kml_out .= "			<open>".$open."</open>";
    $kml_out .= "			<description>";
    $kml_out .= "				".$description;
    $kml_out .= "			</description>";
    $kml_out .= "			<refreshVisibility>".$refreshVis."</refreshVisibility>";
    $kml_out .= "			<flyToView>".$flyToView."</flyToView>";
    $kml_out .= "			<Link>";
    $kml_out .= "				<href>".$url."</href>";
    $kml_out .= "			</Link>";
    $kml_out .= "		</NetworkLink>";
    $kml_out .= "</Folder>";

    return $kml_out;
  } // function xmltokml_KML_net
		
  function xmltokml_refreshing_KML_net($url, $name, $description, $vis, $open, $refreshVis, $flyToView, $refreshTime) {
    $kml_out = "<Folder>";
    $kml_out .= "		<name>".$name."</name>";
    $kml_out .= "		<visibility>".$vis."</visibility>";
    $kml_out .= "		<open>".$open."</open>";
    $kml_out .= "		<description>";
    $kml_out .= "			".$description;
    $kml_out .= "		</description>";
    $kml_out .= "		<NetworkLink>";
    $kml_out .= "			<name>".$name."</name>";
    $kml_out .= "			<visibility>".$vis."</visibility>";
    $kml_out .= "			<open>".$open."</open>";
    $kml_out .= "			<description>";
    $kml_out .= "				".$description;
    $kml_out .= "			</description>";
    $kml_out .= "			<refreshVisibility>".$refreshVis."</refreshVisibility>";
    $kml_out .= "			<flyToView>".$flyToView."</flyToView>";
    $kml_out .= "			<Link>";
    $kml_out .= "				<href>".$url."</href>";
    $kml_out .= "				<refreshMode>onInterval</refreshMode>";
    $kml_out .= "				<refreshInterval>".$refreshTime."</refreshInterval>";
    $kml_out .= "			</Link>";
    $kml_out .= "		</NetworkLink>";
    $kml_out .= "</Folder>";

    return $kml_out;
  } // function xmltokml_refreshing_KML_net

  /**
   * Print a Placemark element.
   *
   * @param $title
   *   The title of the Drupal node.
   * @param $description
   *   The description of the Drupal node. Author name, body, and possibly image.
   * @param $start_time
   *   The formatted time of the Drupal node creation.
   * @param $end_time
   *   End time. Note, not currently used.
   * @param $lon
   *   The longitude coordinate of the story location.
   * @param $lat
   *   The latitude coordinate of the story location.
   */   
  function xmltokml_KML_placemark($title, $description, $start_time, $end_time, $lon, $lat) {
    $kml_out = '    <Placemark>' . "\r\n";
    $kml_out .= '      <name>' . $title . '</name>' . "\r\n";
    $kml_out .= '      <description>' . $description . '</description>' . "\r\n";
    //$kml_out .= "     <TimeSpan>";
    //$kml_out .= "     	<begin>" . $startTime ."</begin>";
    //$kml_out .= "     	<end>" . $endTime  ."</end>";
    //$kml_out .= "     </TimeSpan>";

    if ($start_time != NULL) {
      $kml_out .= '      <TimeStamp>' . "\r\n";
      $kml_out .= '        <when>' . $start_time .'</when>' . "\r\n";
      $kml_out .= '      </TimeStamp>' . "\r\n";
    }

    $kml_out .= '      <Point>' . "\r\n";
    $kml_out .= '        <coordinates>' . "$lon,$lat" . '</coordinates>' . "\r\n";
    $kml_out .= '      </Point>' . "\r\n";
    $kml_out .= '    </Placemark>' . "\r\n";

    return $kml_out;
  } // function xmltokml_KML_placemark

  function xmltokml_KML_overlay($name, $desc, $image, $north, $south, $east, $west, $rotation) {
    $kml_out = "<GroundOverlay>";
    $kml_out .= "	<name>".$name."</name>";
    $kml_out .= "	<description>";
    $kml_out .= "		".$desc;
    $kml_out .= "	</description>";

    if ($image != NULL) {
      $kml_out .= "	<Icon>";
      $kml_out .= "		<href>".$image."</href>";
      $kml_out .= "	</Icon>";
    }

    $kml_out .= "	<LatLonBox>";
    $kml_out .= "		<north>".$north."</north>";
    $kml_out .= "		<south>".$south."</south>";
    $kml_out .= "		<east>".$east."</east>";
    $kml_out .= "		<west>".$west."</west>";
    $kml_out .= "		<rotation>".$rotation."</rotation>";
    $kml_out .= "	</LatLonBox>";
    $kml_out .= "</GroundOverlay>";

    return $kml_out;
  } // function xmltokml_KML_overlay

  function xmltokml_KML_close() {
    $kml_out = '  </Document>' . "\r\n";
    $kml_out .= '</kml>';

    return $kml_out;
  } // function xmltokml_KML_close
} // class xmltokml_KML_markup
